diff --git a/build.gradle.kts b/build.gradle.kts
index 13974dc..2972ddd 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -23,7 +23,7 @@ tasks.register<Delete>("clean") {
 // =============================================================================
 
 val releaseDir = layout.projectDirectory.dir("release")
-val versionName = "1.0.0-beta4"
+val versionName = "1.0.0-beta8"
 
 val syncDemoLibs by tasks.registering {
     group = "qsmw"
@@ -136,9 +136,64 @@ val packReleaseInfo by tasks.registering {
 
 val copyReleaseStaticFiles by tasks.registering(Copy::class) {
     group = "qsmw"
-    description = "Copy static template files (README.md etc.) into release/"
+    description = "Copy static template files (API_REFERENCE.md etc.) into release/"
     from(layout.projectDirectory.dir("release-template"))
     into(releaseDir)
+    // README.md is generated dynamically from actual artifact sizes / hashes.
+    exclude("README.md")
+}
+
+val generateGitPatch by tasks.registering {
+    group = "qsmw"
+    description = "Generate git patch (diff) from last tag to HEAD"
+    dependsOn(copyReleaseArtifacts)
+    val patchFile = releaseDir.file("changes.patch").asFile
+    outputs.file(patchFile)
+    doLast {
+        val latestTag = try {
+            val stdout = java.io.ByteArrayOutputStream()
+            exec {
+                workingDir = rootDir
+                commandLine("git", "describe", "--tags", "--abbrev=0")
+                standardOutput = stdout
+                errorOutput = java.io.ByteArrayOutputStream()
+                isIgnoreExitValue = true
+            }
+            stdout.toString().trim()
+        } catch (e: Exception) {
+            ""
+        }
+        if (latestTag.isEmpty()) {
+            patchFile.writeText("# No previous git tag found; cannot generate patch.\n")
+            println("WARNING: No previous git tag found, skipping patch generation")
+            return@doLast
+        }
+        patchFile.outputStream().use { out ->
+            exec {
+                workingDir = rootDir
+                commandLine(
+                    "git", "diff", "--binary", "$latestTag..HEAD",
+                    "--", "service/", "contract/", "sdk/", "build.gradle.kts",
+                    "gradle/", "scripts/"
+                )
+                standardOutput = out
+                isIgnoreExitValue = true
+            }
+        }
+        println("Generated ${patchFile.absolutePath} ($latestTag..HEAD)")
+    }
+}
+
+val generateReleaseReadme by tasks.registering(Exec::class) {
+    group = "qsmw"
+    description = "Generate release/README.md from actual artifact sizes and hashes"
+    dependsOn(packReleaseInfo, copyReleaseStaticFiles, generateGitPatch)
+    inputs.dir(releaseDir)
+    outputs.file(releaseDir.file("README.md"))
+    val script = layout.projectDirectory.file("scripts/generate_release_readme.py").asFile
+    val releaseDirPath = releaseDir.asFile.absolutePath
+    executable("python3")
+    args(script.absolutePath, releaseDirPath, versionName)
 }
 
 val packRelease by tasks.registering {
@@ -149,7 +204,9 @@ val packRelease by tasks.registering {
         syncDemoLibs,
         packDemos,
         packReleaseInfo,
-        copyReleaseStaticFiles
+        copyReleaseStaticFiles,
+        generateGitPatch,
+        generateReleaseReadme
     )
     doLast {
         println("\n=== Release packaging done ===")
@@ -159,5 +216,31 @@ val packRelease by tasks.registering {
             ?.forEach { f ->
                 println("  ${f.name}  (${"%,d".format(f.length())} B)")
             }
+
+        // Auto-tag on successful packaging
+        val tagName = "v$versionName"
+        val tagExists = try {
+            val stdout = java.io.ByteArrayOutputStream()
+            exec {
+                workingDir = rootDir
+                commandLine("git", "tag", "-l", tagName)
+                standardOutput = stdout
+                isIgnoreExitValue = true
+            }
+            stdout.toString().trim() == tagName
+        } catch (e: Exception) {
+            false
+        }
+        if (tagExists) {
+            println("\n[SKIP] Git tag '$tagName' already exists.")
+        } else {
+            exec {
+                workingDir = rootDir
+                commandLine("git", "tag", "-a", tagName, "-m", "Release $tagName")
+                isIgnoreExitValue = true
+            }
+            println("\n[OK] Created git tag '$tagName'.")
+        }
+        println("[HINT] Push tag: git push origin $tagName")
     }
 }
diff --git a/contract/src/main/aidl/com/qsjnic/mcu/contract/IMcuKeyListener.aidl b/contract/src/main/aidl/com/qsjnic/mcu/contract/IMcuKeyListener.aidl
new file mode 100644
index 0000000..f0b3b5a
--- /dev/null
+++ b/contract/src/main/aidl/com/qsjnic/mcu/contract/IMcuKeyListener.aidl
@@ -0,0 +1,6 @@
+package com.qsjnic.mcu.contract;
+
+interface IMcuKeyListener {
+    /** Key 0x01: full key-domain event. */
+    void onKeyEvent(int keyValue, int keyStatus);
+}
diff --git a/contract/src/main/aidl/com/qsjnic/mcu/contract/IMcuService.aidl b/contract/src/main/aidl/com/qsjnic/mcu/contract/IMcuService.aidl
index 6ee85ec..2eca439 100644
--- a/contract/src/main/aidl/com/qsjnic/mcu/contract/IMcuService.aidl
+++ b/contract/src/main/aidl/com/qsjnic/mcu/contract/IMcuService.aidl
@@ -7,6 +7,7 @@
 package com.qsjnic.mcu.contract;
 
 import com.qsjnic.mcu.contract.IMcuVehicleListener;
+import com.qsjnic.mcu.contract.IMcuKeyListener;
 import com.qsjnic.mcu.contract.IMcuRadioListener;
 import com.qsjnic.mcu.contract.IMcuUpgradeListener;
 import com.qsjnic.mcu.contract.VehicleSnapshot;
@@ -207,6 +208,29 @@ interface IMcuService {
 
     // ===== Meta / introspection (added in beta4, AIDL surface remains v2) =====
 
-    /** Returns the Service-side build version (e.g. "1.0.0-beta4"). */
+    /** Returns the Service-side build version (e.g. "1.0.0-beta5"). */
     String getServiceVersion();
+
+    // ===== Protocol-correct extensions (added after beta6 audit; append-only) =====
+
+    /** Radio 0x83 SET_BAND with current frequency payload. */
+    int setBandWithFreq(int band, int freq);
+
+    /** Update 0x86: send boot update 16-byte MD5 checksum. */
+    int sendBootUpgradeChecksumMd5(in byte[] md5);
+
+    /** Public 0x91: request trip meter clear. type: 1=long trip, 2=total, 3=short trip. */
+    int requestTripClearType(int type);
+
+    /** Public 0x94: send full protocol GPS payload. */
+    int setGpsInfoFull(int moduleStatus, int lonPpm, int lonStatus, int latPpm, int latStatus);
+
+    // ===== Key domain (added after beta6 audit; append-only) =====
+
+    /** Subscribe to Key 0x02 domain key events. */
+    void registerKeyListener(in IMcuKeyListener cb);
+    void unregisterKeyListener(in IMcuKeyListener cb);
+
+    /** Key 0x81: send key value/status to MCU. */
+    int sendKeyEvent(int keyValue, int keyStatus);
 }
diff --git a/contract/src/main/java/com/qsjnic/mcu/contract/McuServiceManager.java b/contract/src/main/java/com/qsjnic/mcu/contract/McuServiceManager.java
index 46c001c..ae3a15e 100644
--- a/contract/src/main/java/com/qsjnic/mcu/contract/McuServiceManager.java
+++ b/contract/src/main/java/com/qsjnic/mcu/contract/McuServiceManager.java
@@ -24,7 +24,7 @@ public final class McuServiceManager {
     /** SDK/Service build version string. Read via {@link com.qsjnic.mcu.sdk.McuClient#getSdkVersion()}
      *  without an IPC round-trip, or via the bound Service's
      *  {@code IMcuService.getServiceVersion()} for the live binding's version. */
-    public static final String SDK_VERSION = "1.0.0-beta4";
+    public static final String SDK_VERSION = "1.0.0-beta7";
 
     /** Current AIDL surface version. Bumped on breaking changes. */
     public static final int AIDL_VERSION = 2;
diff --git a/contract/src/main/java/com/qsjnic/mcu/domain/Cmds.java b/contract/src/main/java/com/qsjnic/mcu/domain/Cmds.java
index 95a588e..e815cf5 100644
--- a/contract/src/main/java/com/qsjnic/mcu/domain/Cmds.java
+++ b/contract/src/main/java/com/qsjnic/mcu/domain/Cmds.java
@@ -79,11 +79,21 @@ public final class Cmds {
 
         // M2A
         public static final int M2A_FREQ        = 0x01;
+        public static final int M2A_PS_PTY      = 0x02;
+        public static final int M2A_RT          = 0x03;
         public static final int M2A_TA_PTY_TIPS = 0x04;
+        public static final int M2A_WORK_STATUS = 0x05;
 
         private Radio() {}
     }
 
+    public static final class Key {
+        public static final int M2A_KEY = 0x01;
+        public static final int A2M_KEY = 0x81;
+
+        private Key() {}
+    }
+
     public static final class Update {
         // A2M
         public static final int REQ        = 0x80;
diff --git a/contract/src/main/java/com/qsjnic/mcu/domain/Commands.java b/contract/src/main/java/com/qsjnic/mcu/domain/Commands.java
index a1e6ee0..b748f67 100644
--- a/contract/src/main/java/com/qsjnic/mcu/domain/Commands.java
+++ b/contract/src/main/java/com/qsjnic/mcu/domain/Commands.java
@@ -30,7 +30,6 @@ public final class Commands {
             require(minute >= 0 && minute <= 59, "minute out of range");
             require(second >= 0 && second <= 59, "second out of range");
             return new byte[] {
-                    0x01,
                     (byte) (year - 2000), (byte) month, (byte) day,
                     (byte) hour, (byte) minute, (byte) second
             };
@@ -95,11 +94,16 @@ public final class Commands {
         }
 
         public static byte[] reqTripClear() {
-            return EMPTY;
+            return reqTripClear(1);
+        }
+
+        public static byte[] reqTripClear(int type) {
+            require(type >= 1 && type <= 3, "type out of range");
+            return new byte[] { (byte) type };
         }
 
         public static byte[] switchStatus(int switchBitmap) {
-            require(switchBitmap >= 0 && switchBitmap <= 0xFFFF, "bitmap out of range");
+            require(switchBitmap >= 0 && switchBitmap <= 0xFF, "bitmap out of range");
             return new byte[] { (byte) (switchBitmap & 0xFF) };
         }
 
@@ -109,10 +113,26 @@ public final class Commands {
         }
 
         public static byte[] gpsInfo(int latE6, int lonE6, int speedKmh, int heading) {
+            int lonStatus = (lonE6 < 0 ? 0x02 : 0x00) | (lonE6 == 0 && latE6 == 0 ? 0x00 : 0x01);
+            int latStatus = (latE6 < 0 ? 0x02 : 0x00) | (lonE6 == 0 && latE6 == 0 ? 0x00 : 0x01);
+            return gpsInfoFull(0, Math.abs(lonE6), lonStatus, Math.abs(latE6), latStatus);
+        }
+
+        public static byte[] gpsInfoFull(int moduleStatus, int lonPpm, int lonStatus,
+                                         int latPpm, int latStatus) {
+            require(moduleStatus >= 0 && moduleStatus <= 0xFF, "moduleStatus out of range");
+            require(lonPpm >= 0, "lonPpm must be non-negative");
+            require(lonStatus >= 0 && lonStatus <= 0xFF, "lonStatus out of range");
+            require(latPpm >= 0, "latPpm must be non-negative");
+            require(latStatus >= 0 && latStatus <= 0xFF, "latStatus out of range");
             return new byte[] {
-                    (byte) ((latE6 >> 16) & 0xFF), (byte) ((latE6 >> 8) & 0xFF), (byte) (latE6 & 0xFF),
-                    (byte) ((lonE6 >> 16) & 0xFF), (byte) ((lonE6 >> 8) & 0xFF), (byte) (lonE6 & 0xFF),
-                    (byte) speedKmh, (byte) heading
+                    (byte) moduleStatus,
+                    (byte) ((lonPpm >> 24) & 0xFF), (byte) ((lonPpm >> 16) & 0xFF),
+                    (byte) ((lonPpm >> 8) & 0xFF),  (byte) (lonPpm & 0xFF),
+                    (byte) lonStatus,
+                    (byte) ((latPpm >> 24) & 0xFF), (byte) ((latPpm >> 16) & 0xFF),
+                    (byte) ((latPpm >> 8) & 0xFF),  (byte) (latPpm & 0xFF),
+                    (byte) latStatus
             };
         }
 
@@ -130,10 +150,12 @@ public final class Commands {
         }
 
         public static byte[] fuelCal(byte[] data) {
+            require(data == null || data.length == 2, "fuelCal payload must be 2 bytes");
             return data == null ? EMPTY : data;
         }
 
         public static byte[] vehicleCfg(byte[] data) {
+            require(data == null || data.length == 16, "vehicleCfg payload must be 16 bytes");
             return data == null ? EMPTY : data;
         }
 
@@ -143,12 +165,12 @@ public final class Commands {
 
         public static byte[] armSwVersion(String version) {
             require(version != null, "version is null");
-            return version.getBytes(StandardCharsets.UTF_8);
+            return versionPayload(version);
         }
 
         public static byte[] armHwVersion(String version) {
             require(version != null, "version is null");
-            return version.getBytes(StandardCharsets.UTF_8);
+            return versionPayload(version);
         }
 
         public static byte[] autoClearMeterType(int type) {
@@ -170,8 +192,13 @@ public final class Commands {
     public static final class Radio {
 
         public static byte[] setBand(int band) {
+            return setBand(band, 0);
+        }
+
+        public static byte[] setBand(int band, int freq) {
             require(band >= 0 && band <= 1, "band out of range");
-            return new byte[] { (byte) band };
+            require(freq >= 0 && freq <= 0xFFFF, "freq out of range");
+            return new byte[] { (byte) band, (byte) ((freq >> 8) & 0xFF), (byte) (freq & 0xFF) };
         }
 
         public static byte[] setFrequency(int freq) {
@@ -212,12 +239,35 @@ public final class Commands {
         private Radio() {}
     }
 
+    public static final class Key {
+
+        public static byte[] key(int keyValue, int keyStatus) {
+            require(keyValue >= 0 && keyValue <= 0x25, "keyValue out of range (Pajero 0x00-0x25)");
+            require(keyStatus >= 0 && keyStatus <= 0x04, "keyStatus out of range");
+            return new byte[] { (byte) keyValue, (byte) keyStatus };
+        }
+
+        private Key() {}
+    }
+
     public static final class Update {
 
         public static byte[] bootBegin() {
             return EMPTY;
         }
 
+        public static byte[] bootBegin(long binSize, String projectId) {
+            require(binSize >= 0 && binSize <= 0xFFFFFFFFL, "binSize out of range");
+            byte[] project = projectBytes(projectId);
+            byte[] payload = new byte[4 + project.length];
+            payload[0] = (byte) ((binSize >> 24) & 0xFF);
+            payload[1] = (byte) ((binSize >> 16) & 0xFF);
+            payload[2] = (byte) ((binSize >> 8) & 0xFF);
+            payload[3] = (byte) (binSize & 0xFF);
+            System.arraycopy(project, 0, payload, 4, project.length);
+            return payload;
+        }
+
         public static byte[] bootData(byte[] chunk, int index) {
             require(chunk != null, "chunk is null");
             byte[] payload = new byte[2 + chunk.length];
@@ -234,6 +284,13 @@ public final class Commands {
             };
         }
 
+        public static byte[] bootChecksumMd5(byte[] md5) {
+            require(md5 != null && md5.length == 16, "md5 must be 16 bytes");
+            byte[] payload = new byte[16];
+            System.arraycopy(md5, 0, payload, 0, 16);
+            return payload;
+        }
+
         private Update() {}
     }
 
@@ -243,5 +300,20 @@ public final class Commands {
         if (!cond) throw new IllegalArgumentException(msg);
     }
 
+    private static byte[] versionPayload(String version) {
+        byte[] text = version.getBytes(StandardCharsets.UTF_8);
+        require(text.length <= 0xFF, "version too long");
+        byte[] payload = new byte[1 + text.length];
+        payload[0] = (byte) text.length;
+        System.arraycopy(text, 0, payload, 1, text.length);
+        return payload;
+    }
+
+    private static byte[] projectBytes(String projectId) {
+        String project = projectId == null ? "" : projectId;
+        require(project.length() <= 5, "projectId too long");
+        return project.getBytes(StandardCharsets.US_ASCII);
+    }
+
     private Commands() {}
 }
diff --git a/contract/src/main/java/com/qsjnic/mcu/domain/Decoders.java b/contract/src/main/java/com/qsjnic/mcu/domain/Decoders.java
index 6ed33f3..cfd3127 100644
--- a/contract/src/main/java/com/qsjnic/mcu/domain/Decoders.java
+++ b/contract/src/main/java/com/qsjnic/mcu/domain/Decoders.java
@@ -18,7 +18,8 @@ public final class Decoders {
 
     public static int parseVoltage(byte[] body) {
         if (body == null || body.length < 2) return -1;
-        return ((body[0] & 0xFF) << 8) | (body[1] & 0xFF);
+        int tenthVolt = ((body[0] & 0xFF) << 8) | (body[1] & 0xFF);
+        return tenthVolt * 100;
     }
 
     public static int parseSysStatus(byte[] body) {
@@ -42,14 +43,15 @@ public final class Decoders {
     }
 
     public static int parseCarSpeed(byte[] body) {
-        if (body == null || body.length < 1) return -1;
-        return body[0] & 0xFF;
+        if (body == null || body.length < 2) return -1;
+        return ((body[0] & 0xFF) << 8) | (body[1] & 0xFF);
     }
 
     public static int parseMileage(byte[] body) {
         if (body == null || body.length < 4) return -1;
-        return ((body[0] & 0xFF) << 24) | ((body[1] & 0xFF) << 16)
-             | ((body[2] & 0xFF) << 8)  | (body[3] & 0xFF);
+        int offset = body.length >= 8 ? 4 : 0;
+        return ((body[offset] & 0xFF) << 24) | ((body[offset + 1] & 0xFF) << 16)
+             | ((body[offset + 2] & 0xFF) << 8)  | (body[offset + 3] & 0xFF);
     }
 
     public static int parseSwitchStatus(byte[] body) {
@@ -68,13 +70,12 @@ public final class Decoders {
     }
 
     public static int parseBattVoltage(byte[] body) {
-        if (body == null || body.length < 2) return -1;
-        return ((body[0] & 0xFF) << 8) | (body[1] & 0xFF);
+        return -1;
     }
 
     public static int parseBattPercent(byte[] body) {
-        if (body == null || body.length < 3) return -1;
-        return body[2] & 0xFF;
+        if (body == null || body.length < 1) return -1;
+        return body[0] & 0xFF;
     }
 
     /** Returns [isSet, year(2000+), month, day, hour, minute, second] or null. */
@@ -113,6 +114,27 @@ public final class Decoders {
 
     // ------------------------------------------------------------ Radio
 
+    /** Returns [pi, pty, ps] or null. Protocol carries PTY + 8-byte PS; pi is kept as 0 for AIDL compatibility. */
+    public static Object[] parsePsPty(byte[] body) {
+        if (body == null || body.length < 1) return null;
+        int pi  = 0;
+        int pty = body[0] & 0xFF;
+        String ps = body.length > 1 ? trimUtf8(body, 1, body.length - 1) : "";
+        return new Object[] { pi, pty, ps };
+    }
+
+    /** Returns RT (Radio Text) string, or empty string. */
+    public static String parseRadioText(byte[] body) {
+        if (body == null || body.length == 0) return "";
+        return trimUtf8(body, 0, body.length);
+    }
+
+    /** Returns work status code, or -1. */
+    public static int parseWorkStatus(byte[] body) {
+        if (body == null || body.length < 1) return -1;
+        return body[0] & 0xFF;
+    }
+
     public static RadioFreq parseRadioFreq(byte[] body) {
         if (body == null || body.length < 7) return null;
         RadioFreq f = new RadioFreq();
@@ -122,6 +144,14 @@ public final class Decoders {
         return f;
     }
 
+    // ------------------------------------------------------------ Key
+
+    /** Returns [keyValue, keyStatus] or null. */
+    public static int[] parseKeyControl(byte[] body) {
+        if (body == null || body.length < 2) return null;
+        return new int[] { body[0] & 0xFF, body[1] & 0xFF };
+    }
+
     /** Returns [mode, value] or null. */
     public static int[] parseTaPtyTips(byte[] body) {
         if (body == null || body.length < 1) return null;
diff --git a/contract/src/main/java/com/qsjnic/mcu/domain/MsgType.java b/contract/src/main/java/com/qsjnic/mcu/domain/MsgType.java
index eb2c16a..6c738da 100644
--- a/contract/src/main/java/com/qsjnic/mcu/domain/MsgType.java
+++ b/contract/src/main/java/com/qsjnic/mcu/domain/MsgType.java
@@ -3,6 +3,7 @@ package com.qsjnic.mcu.domain;
 /** Message type constants (module ID). */
 public final class MsgType {
     public static final int PUBLIC = 0x01;
+    public static final int KEY    = 0x02;
     public static final int RADIO  = 0x05;
     public static final int UPDATE = 0x07;
 
diff --git a/contract/src/test/java/com/qsjnic/mcu/domain/CommandsMoreTest.java b/contract/src/test/java/com/qsjnic/mcu/domain/CommandsMoreTest.java
index dfa1a78..3d4ed51 100644
--- a/contract/src/test/java/com/qsjnic/mcu/domain/CommandsMoreTest.java
+++ b/contract/src/test/java/com/qsjnic/mcu/domain/CommandsMoreTest.java
@@ -53,11 +53,11 @@ public class CommandsMoreTest {
     }
 
     @Test public void setBand_fm() {
-        assertArrayEquals(new byte[]{0}, Commands.Radio.setBand(0));
+        assertArrayEquals(new byte[]{0, 0, 0}, Commands.Radio.setBand(0));
     }
 
     @Test public void setBand_am() {
-        assertArrayEquals(new byte[]{1}, Commands.Radio.setBand(1));
+        assertArrayEquals(new byte[]{1, 0, 0}, Commands.Radio.setBand(1));
     }
 
     @Test public void setFrequency_0() {
diff --git a/contract/src/test/java/com/qsjnic/mcu/domain/CommandsTest.java b/contract/src/test/java/com/qsjnic/mcu/domain/CommandsTest.java
index 2350266..1929472 100644
--- a/contract/src/test/java/com/qsjnic/mcu/domain/CommandsTest.java
+++ b/contract/src/test/java/com/qsjnic/mcu/domain/CommandsTest.java
@@ -26,7 +26,7 @@ public class CommandsTest {
     @Test
     public void timeInfo_basic() {
         assertArrayEquals(
-                new byte[] { 1, 26, 5, 16, 14, 30, 0 },
+                new byte[] { 26, 5, 16, 14, 30, 0 },
                 Commands.Public.timeInfo(2026, 5, 16, 14, 30, 0));
     }
 
@@ -133,7 +133,12 @@ public class CommandsTest {
 
     @Test
     public void reqTripClear_returnsEmpty() {
-        assertArrayEquals(new byte[0], Commands.Public.reqTripClear());
+        assertArrayEquals(new byte[] { 1 }, Commands.Public.reqTripClear());
+    }
+
+    @Test
+    public void reqTripClear_type() {
+        assertArrayEquals(new byte[] { 3 }, Commands.Public.reqTripClear(3));
     }
 
     @Test
@@ -150,9 +155,11 @@ public class CommandsTest {
     public void gpsInfo() {
         assertArrayEquals(
                 new byte[] {
-                        0x12, 0x34, 0x56,   // latE6 = 0x123456
-                        0x78, (byte)0x9A, (byte)0xBC, // lonE6 = 0x789ABC
-                        60, (byte)180
+                        0x00,
+                        0x00, 0x78, (byte)0x9A, (byte)0xBC,
+                        0x01,
+                        0x00, 0x12, 0x34, 0x56,
+                        0x01
                 },
                 Commands.Public.gpsInfo(0x123456, 0x789ABC, 60, 180));
     }
@@ -181,7 +188,7 @@ public class CommandsTest {
 
     @Test
     public void vehicleCfg_raw() {
-        byte[] raw = new byte[] { 1, 2, 3 };
+        byte[] raw = new byte[16];
         assertSame(raw, Commands.Public.vehicleCfg(raw));
     }
 
@@ -192,7 +199,7 @@ public class CommandsTest {
 
     @Test
     public void armSwVersion() {
-        byte[] expected = "v1.2.3".getBytes(java.nio.charset.StandardCharsets.UTF_8);
+        byte[] expected = new byte[] { 6, 'v', '1', '.', '2', '.', '3' };
         assertArrayEquals(expected, Commands.Public.armSwVersion("v1.2.3"));
     }
 
@@ -203,7 +210,7 @@ public class CommandsTest {
 
     @Test
     public void armHwVersion() {
-        byte[] expected = "HW-A".getBytes(java.nio.charset.StandardCharsets.UTF_8);
+        byte[] expected = new byte[] { 4, 'H', 'W', '-', 'A' };
         assertArrayEquals(expected, Commands.Public.armHwVersion("HW-A"));
     }
 
@@ -227,12 +234,17 @@ public class CommandsTest {
 
     @Test
     public void setBand_fm() {
-        assertArrayEquals(new byte[] { 0 }, Commands.Radio.setBand(0));
+        assertArrayEquals(new byte[] { 0, 0, 0 }, Commands.Radio.setBand(0));
     }
 
     @Test
     public void setBand_am() {
-        assertArrayEquals(new byte[] { 1 }, Commands.Radio.setBand(1));
+        assertArrayEquals(new byte[] { 1, 0, 0 }, Commands.Radio.setBand(1));
+    }
+
+    @Test
+    public void setBand_withFreq() {
+        assertArrayEquals(new byte[] { 0, 0x22, 0x2E }, Commands.Radio.setBand(0, 0x222E));
     }
 
     @Test(expected = IllegalArgumentException.class)
@@ -245,6 +257,23 @@ public class CommandsTest {
         assertArrayEquals(new byte[] { 0x22, 0x2E }, Commands.Radio.setFrequency(0x222E));
     }
 
+    // ---- Key ----
+
+    @Test
+    public void keyDomainEvent() {
+        assertArrayEquals(new byte[] { 0x01, 0x01 }, Commands.Key.key(1, 1));
+    }
+
+    @Test(expected = IllegalArgumentException.class)
+    public void keyDomainEvent_valueTooHigh() {
+        Commands.Key.key(0x0C, 1);
+    }
+
+    @Test(expected = IllegalArgumentException.class)
+    public void keyDomainEvent_statusTooHigh() {
+        Commands.Key.key(1, 0x05);
+    }
+
     @Test
     public void setFreqRange() {
         assertArrayEquals(
@@ -279,6 +308,13 @@ public class CommandsTest {
         assertArrayEquals(new byte[0], Commands.Update.bootBegin());
     }
 
+    @Test
+    public void bootBegin_protocolPayload() {
+        assertArrayEquals(
+                new byte[] { 0, 0, 0x10, 0x00, '1', '0', '0', '4', '0' },
+                Commands.Update.bootBegin(0x1000, "10040"));
+    }
+
     @Test
     public void bootData() {
         byte[] chunk = new byte[] { 0x0A, 0x0B };
@@ -298,4 +334,11 @@ public class CommandsTest {
                 new byte[] { 0x12, 0x34, 0x56, 0x78 },
                 Commands.Update.bootChecksum(0x12345678));
     }
+
+    @Test
+    public void bootChecksumMd5() {
+        byte[] md5 = new byte[16];
+        md5[15] = 1;
+        assertArrayEquals(md5, Commands.Update.bootChecksumMd5(md5));
+    }
 }
diff --git a/contract/src/test/java/com/qsjnic/mcu/domain/DecodersTest.java b/contract/src/test/java/com/qsjnic/mcu/domain/DecodersTest.java
index 8222b3c..e499c9c 100644
--- a/contract/src/test/java/com/qsjnic/mcu/domain/DecodersTest.java
+++ b/contract/src/test/java/com/qsjnic/mcu/domain/DecodersTest.java
@@ -34,7 +34,7 @@ public class DecodersTest {
 
     @Test
     public void parseVoltage_basic() {
-        assertEquals(0x30D4, Decoders.parseVoltage(new byte[] { 0x30, (byte)0xD4 }));
+        assertEquals(12800, Decoders.parseVoltage(new byte[] { 0x00, (byte)0x80 }));
     }
 
     @Test
@@ -59,12 +59,14 @@ public class DecodersTest {
 
     @Test
     public void parseCarSpeed() {
-        assertEquals(60, Decoders.parseCarSpeed(new byte[] { 60 }));
+        assertEquals(60, Decoders.parseCarSpeed(new byte[] { 0, 60, 100 }));
     }
 
     @Test
     public void parseMileage() {
-        assertEquals(0x12345678, Decoders.parseMileage(new byte[] { 0x12, 0x34, 0x56, 0x78 }));
+        assertEquals(0x01020304, Decoders.parseMileage(new byte[] {
+                0x12, 0x34, 0x56, 0x78, 0x01, 0x02, 0x03, 0x04
+        }));
     }
 
     @Test
@@ -143,4 +145,26 @@ public class DecodersTest {
         assertArrayEquals(in, out);
         assertNotSame(in, out);
     }
+
+    @Test
+    public void parsePsPty_protocolShape() {
+        Object[] v = Decoders.parsePsPty(new byte[] { 5, 'P', 'S', 0, 0, 0, 0, 0, 0 });
+        assertNotNull(v);
+        assertEquals(0, v[0]);
+        assertEquals(5, v[1]);
+        assertEquals("PS", v[2]);
+    }
+
+    @Test
+    public void parseKeyControl() {
+        int[] v = Decoders.parseKeyControl(new byte[] { 0x0A, 0x01 });
+        assertNotNull(v);
+        assertEquals(0x0A, v[0]);
+        assertEquals(0x01, v[1]);
+    }
+
+    @Test
+    public void parseKeyControl_tooShort() {
+        assertNull(Decoders.parseKeyControl(new byte[] { 0x01 }));
+    }
 }
diff --git a/gradle/libs.versions.toml b/gradle/libs.versions.toml
index 273885b..636c9cc 100644
--- a/gradle/libs.versions.toml
+++ b/gradle/libs.versions.toml
@@ -1,5 +1,5 @@
 [versions]
-agp = "8.2.2"
+agp = "8.8.2"
 kotlin = "1.9.22"
 
 # Android SDK / Java
